var http = require('http');
var process = require('child_process');
var WebSocketServer = require("ws").Server;
var events = require("events");
var jsoncompress = require('jsoncompress');
var net = require('net');
var fs = require('fs');

var config = require('./config');
var logger = require("./logger");
var _cycle = require("./cycle");
var CycleBuffer = require("./graphBuffer");

var client = new net.Socket(config.CTL_SOCKET, function() {
	logger.log("Connected");
	client.write("Hello world");
});

client.on('data', function(data) {
	
});

client.on('close', function() {
	console.log("Connection closed");
});
